# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define stax2_version 2.1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/woodstox/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           wstx32
Version:        3.2.6
Release:        2%{?dist}
Epoch:          0
Summary:        Woodstox Stax Implementation
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://woodstox.codehaus.org/
Source0:        http://repository.codehaus.org/org/codehaus/woodstox/wstx-lgpl/3.2.6/wstx-src-3.2.6.tar.gz
Source1:        wstx-asl-3.2.6.pom
Source2:        wstx-lgpl-3.2.6.pom
Source3:        wstx-component-info.xml
Requires:       bea-stax-api >= 0:1.2.0
Requires:       msv-msv
Requires:       msv-xsdlib
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-nodeps
BuildRequires:  ant-apache-bcel
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  bea-stax-api >= 0:1.2.0
BuildRequires:  emma
BuildRequires:  msv-msv
BuildRequires:  msv-xsdlib
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description
Woodstox is a high-performance validating namespace-aware 
StAX-compliant (JSR-173) Open Source XML-processor written 
in Java.
XML processor means that it handles both input (== parsing) 
and output (== writing, serialization)), as well as 
supporting tasks such as validation.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package j2me
Group:          Development/Libraries/Java
Summary:        J2ME libraries for %{name}

%description j2me
%{summary}.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q -c -n %{name}
find . -name '*.?ar' | xargs -t %{__rm}

pushd release-notes
mv CREDITS{,.orig}
mv VERSION{,.orig}
%{_bindir}/iconv -f iso-8859-1 -t utf8 -o CREDITS CREDITS.orig
%{_bindir}/iconv -f iso-8859-1 -t utf8 -o VERSION VERSION.orig
rm CREDITS.orig
rm VERSION.orig
popd

pushd lib
ln -sf $(build-classpath emma) .
ln -sf $(build-classpath emma_ant) .
ln -sf $(build-classpath bea-stax-api) stax-api-1.0.jar
pushd msv
ln -sf $(build-classpath msv-msv) msv.jar
ln -sf $(build-classpath msv-xsdlib) xsdlib.jar
ln -sf $(build-classpath relaxngDatatype) .
popd
popd

%build
export CLASSPATH=
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/{nodeps,apache-bcel,junit,trax}`"
%{ant} jars jars.j2me javadoc test staxtest

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 644 build/stax2-%{stax2_version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/stax2-%{version}.jar
install -p -m 644 build/wstx-api-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-api-%{version}.jar
install -p -m 644 build/wstx-asl-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-asl-%{version}.jar
install -p -m 644 build/wstx-lgpl-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-lgpl-%{version}.jar
install -p -m 644 build/wstx-j2me-min-both.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-j2me-min-both-%{version}.jar
install -p -m 644 build/wstx-j2me-min-input.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-j2me-min-input-%{version}.jar
install -p -m 644 build/wstx-j2me-min-output.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/wstx-j2me-min-output-%{version}.jar
# create unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

%add_to_maven_depmap org.codehaus.woodstox stax2 %{version} JPP/%{name} stax2
%add_to_maven_depmap org.codehaus.woodstox wstx-api %{version} JPP/%{name} wstx-api
%add_to_maven_depmap org.codehaus.woodstox wstx-asl %{version} JPP/%{name} wstx-asl
%add_to_maven_depmap org.codehaus.woodstox wstx-lgpl %{version} JPP/%{name} wstx-lgpl
%add_to_maven_depmap org.codehaus.woodstox wstx-j2me-min-both %{version} JPP/%{name} wstx-j2me-min-both
%add_to_maven_depmap org.codehaus.woodstox wstx-j2me-min-input %{version} JPP/%{name} wstx-j2me-min-input
%add_to_maven_depmap org.codehaus.woodstox wstx-j2me-min-output %{version} JPP/%{name} wstx-j2me-min-output

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-wstx-asl.pom
install -p -m 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-wstx-lgpl.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadoc/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr release-notes/* \
    $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{with_repolib}
install -d -m 0755 $RPM_BUILD_ROOT%{repodir}
install -d -m 0755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 0755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 0644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/wstx32/wstx-lgpl.jar $RPM_BUILD_ROOT%{repodirlib}/wstx32.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/stax2*.jar
%{_javadir}/%{name}/wstx-api*.jar
%{_javadir}/%{name}/wstx-asl*.jar
%{_javadir}/%{name}/wstx-lgpl*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files j2me
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/wstx-j2me-min-both*.jar
%{_javadir}/%{name}/wstx-j2me-min-input*.jar
%{_javadir}/%{name}/wstx-j2me-min-output*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Mar 23 2009 Ralph Apel <r.apel@r-apel.de> 0:3.2.6-2.jpp5
- rename to wstx32 because of frozen wstx in JPP-5
- fix jpackage-utils BR to >= 1.7.3 - otherwise no depmap frags

* Mon Jan 12 2009 David Walluck <dwalluck@redhat.com> 0:3.2.6-2
- use install -p
- fix repolib

* Fri Jan 09 2009 David Walluck <dwalluck@redhat.com> 0:3.2.6-1
- 3.2.6

* Tue Jul 29 2008 David Walluck <dwalluck@redhat.com> 0:3.1.1-3
- fix maven frag attributes
- fix repolib permissions

* Wed May 28 2008 David Walluck <dwalluck@redhat.com> 0:3.1.1-2.jpp5
- own %%{_javadir}/%%{name}
- merge in maven2 changes from 3.2.1-1jpp
- fix License
- fix javadoc location
- BuildRequires: ant-trax

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 0:3.1.1-1jpp.ep1.1
- Rebuild

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.el4ep1.2
- Add -brew suffix

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp.el4ep1.1
- First build for EP branch
- Add repolib support

* Mon Feb 26 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:3.1.1-1jpp
- Upgrade to 3.1.1
- Fix javadoc handling to remove ghost + linking magic

* Fri May 05 2006 Ralph Apel <r.apel@r-apel.de> 0:2.9.3-1jpp
- First build
